--addon name, addon namespace
local _, ans = ...;

local buttons = {
    CharacterMicroButton,
    SpellbookMicroButton,
    TalentMicroButton,
    AchievementMicroButton,
    QuestLogMicroButton,
    GuildMicroButton,
    LFDMicroButton,
    CollectionsMicroButton,
    EJMicroButton,
    StoreMicroButton,
    MainMenuMicroButton,
    MainMenuBarBackpackButton,
    BagBarExpandToggle,
    CharacterReagentBag0Slot,
    CharacterBag0Slot,
    CharacterBag1Slot,
    CharacterBag2Slot,
    CharacterBag3Slot
};
local hideTimer;

local function show()
    ans.cancelTimer(hideTimer);
    MicroButtonAndBagsBar:SetAlpha(1);
end

local function hide()
    hideTimer = ans.createTimer(function()
        MicroButtonAndBagsBar:SetAlpha(0);
    end);
end

--[[
    Micro buttons and bags are visible on hover
]]--
local function MicroButtons_load()
    if (KdoUiData.MicroButtonAndBagsBarOnLeft) then
        -- BagsBar orientation to the right
        MicroButtonAndBagsBar:ClearAllPoints();
        MicroButtonAndBagsBar:SetPoint("BOTTOMLEFT", QuickJoinToastButton, "TOPLEFT", 0, 4);
        BagBarExpandToggle:ClearAllPoints();
        BagBarExpandToggle:SetPoint("LEFT", MainMenuBarBackpackButton, "RIGHT");
        CharacterBag0Slot:ClearAllPoints();
        CharacterBag0Slot:SetPoint("LEFT", BagBarExpandToggle, "RIGHT");
        CharacterBag1Slot:ClearAllPoints();
        CharacterBag1Slot:SetPoint("LEFT", CharacterBag0Slot, "RIGHT");
        CharacterBag2Slot:ClearAllPoints();
        CharacterBag2Slot:SetPoint("LEFT", CharacterBag1Slot, "RIGHT");
        CharacterBag3Slot:ClearAllPoints();
        CharacterBag3Slot:SetPoint("LEFT", CharacterBag2Slot, "RIGHT");
        CharacterReagentBag0Slot:ClearAllPoints();
        CharacterReagentBag0Slot:SetPoint("LEFT", CharacterBag3Slot:IsShown() and CharacterBag3Slot or BagBarExpandToggle, "RIGHT");
        MainMenuBarBackpackButton:ClearAllPoints();
        MainMenuBarBackpackButton:SetPoint("TOPLEFT", MicroButtonAndBagsBar, "TOPLEFT", 4, 2);
        hooksecurefunc(CharacterReagentBag0Slot, "SetBarExpanded", function(self, isExpanded)
            self:ClearAllPoints();
            self:SetPoint("LEFT", isExpanded and CharacterBag3Slot or BagBarExpandToggle, "RIGHT");
        end)


        -- QueueStatusButton on Left of Minimap
        QueueStatusButton:SetParent(Minimap);
        QueueStatusButton:ClearAllPoints();
        QueueStatusButton:SetPoint("RIGHT", Minimap, "LEFT", -8, 0);
    end

    if (KdoUiData.ShowMicroButtonAndBagsBarOnHover) then
        -- Show MicroButtonAndBagsBar on mouse hover
        MicroButtonAndBagsBar:HookScript("OnEnter", show);
        MicroButtonAndBagsBar:HookScript("OnLeave", hide);

        -- Show MicroButtonAndBagsBar on mouse hover buttons
        for _, button in ipairs(buttons) do
            button:HookScript("OnEnter", show);
            button:HookScript("OnLeave", hide);
        end

        -- Hide by default
        hide();
    end
end

ans.MicroButtons_load = MicroButtons_load;